/*
*  Rubrica
*  file: view.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gnome.h>

#include "rubrica.h"

VistaDati vista;
guint scheda_corrente = 0;

void rubrica_view_init(/* GtkWidget *label_file, GtkWidget *label_path, */
		       GtkWidget *schede, GtkWidget *dati, GtkWidget *pbar, 
		       gchar *titolo)
{
  /* GtkWidget */
  vista.schede         = schede;             /* cards clist */
  vista.dati           = dati;               /* data  clist */
  vista.progressbar    = pbar;               /* progressbar */ 
//  vista.label_nomefile = label_file;         /* GtkWidget label for filename */ 
//  vista.label_path     = label_path;         /* GtkWidget label for path */
 
 
  vista.schedeinfo.riga    = 0;              /* row selected in cards clist    */
  vista.schedeinfo.colonna = 0;              /* column selected in cards clist */  
  vista.schedeinfo.selezionato = FALSE;      /* selected/unselected clist row  */

  vista.maxrow  = 0;  
  vista.maxcol  = 0; 
  vista.totale_indirizzi = 0;                /* inserted items */ 

  rubrica_view_set_titolo(titolo);                 
}


void rubrica_view_get_vista(VistaDati *v)
{
  v->schede = vista.schede;
  v->dati = vista.dati;
  v->progressbar = vista.progressbar;
 
//  v->label_nomefile = vista.label_nomefile;
//  v->label_path = vista.label_path;

  v->schedeinfo.riga    = vista.schedeinfo.riga ;
  v->schedeinfo.colonna = vista.schedeinfo.colonna;
  v->schedeinfo.selezionato = vista.schedeinfo.selezionato;

  v->datiinfo.riga = vista.datiinfo.riga;
  v->datiinfo.colonna = vista.datiinfo.colonna ;
  v->datiinfo.selezionato = vista.datiinfo.selezionato ;

  v->maxrow  = vista.maxrow;
  v->maxcol  = vista.maxcol;
  v->totale_indirizzi = vista.totale_indirizzi ;
}


GtkCList *rubrica_view_get_schede(void)
{
  return GTK_CLIST(vista.schede);
}

void rubrica_view_set_schede(GtkWidget *clist)
{
  vista.schede = clist;
}

GtkCList *rubrica_view_get_dati(void)
{
  return GTK_CLIST(vista.dati);
}


/*  gestione label
*/
/*
GtkWidget *rubrica_view_get_path_label_ptr(void)
{
  return (GtkWidget *) vista.label_path;
}


void rubrica_view_set_path_label_ptr(GtkWidget *lbl)
{
  vista.label_path = lbl;
}
*/

/*
void rubrica_view_set_file_label_str(gchar *str)
{
  GtkWidget *label;

  label = vista.label_nomefile;

  if (str)
    gtk_label_set_text(GTK_LABEL(label), str);
  else
    gtk_label_set_text(GTK_LABEL(label), _("no name"));  
}

gchar *rubrica_view_get_file_label_str(void)
{
  gchar *str;

  gtk_label_get(GTK_LABEL(vista.label_nomefile), &str);
  return g_strdup(str);
}


void rubrica_view_set_path_label_str(gchar *str)
{
  if (str)
    gtk_label_set_text(GTK_LABEL(vista.label_path), str);
  else
    gtk_label_set_text(GTK_LABEL(vista.label_path), "");   
}

gchar *rubrica_view_get_path_label_str(void)
{
  gchar *str;

  gtk_label_get(GTK_LABEL(vista.label_path), &str);
  return g_strdup(str);
}
*/


/*   gestione info
*/
void rubrica_view_set_info(InfoRubrica i, TIPO_VISTA t)
{
  if (vista.maxrow < i.riga)
    vista.maxrow = i.riga;
  if (vista.maxcol < i.colonna)
    vista.maxcol = i.colonna;  

  switch (t)
    {
    case VISTA_SCHEDE:
      vista.schedeinfo.riga = i.riga;
      vista.schedeinfo.colonna = i.colonna;
      vista.schedeinfo.selezionato = i.selezionato;
      break;
	
    case VISTA_DATI:
      vista.datiinfo.riga = i.riga;
      vista.datiinfo.colonna = i.colonna;
      vista.datiinfo.selezionato = i.selezionato;  
      break;
	
    default:
      break;
    }
}

void rubrica_view_get_info(InfoRubrica *i, TIPO_VISTA t)
{
  switch (t)
    {
      case VISTA_SCHEDE:
      i->riga    = vista.schedeinfo.riga;
      i->colonna = vista.schedeinfo.colonna;
      i->selezionato = vista.schedeinfo.selezionato;  
      break;

    case VISTA_DATI:
      i->riga    = vista.datiinfo.riga;
      i->colonna = vista.datiinfo.colonna;
      i->selezionato = vista.datiinfo.selezionato; 
      break;

    default:
      break;
    }
}

/*  gestione indirizzi
*/
inline gint rubrica_view_get_indirizzi(void)
{
  return (gint) vista.totale_indirizzi;
}

inline void rubrica_view_set_indirizzi(gint n)
{
  vista.totale_indirizzi = n;

  gtk_progress_set_value(GTK_PROGRESS(vista.progressbar), 
			 (float) vista.totale_indirizzi);
}

inline void rubrica_view_inc_indirizzi(void)
{
  vista.totale_indirizzi++;
}

inline void rubrica_view_dec_indirizzi(void)
{
  vista.totale_indirizzi--;
}

void rubrica_view_set_max_row_col(gint row, gint col)
{
  vista.maxrow = row;
  vista.maxcol = col;
}

void rubrica_view_get_max_row_col(gint *row, gint *col)
{
  *row = vista.maxrow;
  *col = vista.maxcol;
}

/*  gestione clist
*/
inline void rubrica_view_set_scheda_corrente(gint n)
{
  scheda_corrente = n;
}

inline gint rubrica_view_get_scheda_corrente(void)
{
  return (gint) scheda_corrente;
}

void rubrica_view_set_titolo(gchar *titolo)
{  
  g_return_if_fail(titolo != NULL);

  if (strlen(titolo) > 20)
    {
      strncpy(vista.titolo, titolo, 20);
      vista.titolo[21] = '\0';
    }
  else
    strcpy(vista.titolo, titolo);
}

gchar *rubrica_view_get_titolo(void)
{
  return (gchar*) vista.titolo;
}


